/*
 * TransactionInterceptor.java
 *
 * Created on November 15, 2006, 10:10 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package be.aca.misc.ejb3;

import javax.interceptor.AroundInvoke;
import javax.interceptor.InvocationContext;
import javax.naming.InitialContext;
import javax.naming.NameNotFoundException;

/**
 *
 * @author stijn
 */
public class TransactionInterceptor {
    
    @AroundInvoke
    public Object checkComplianceWithEJBSpec(InvocationContext ictx) throws Exception{
         try {
            InitialContext ctx = new InitialContext();
            ctx.lookup("java:comp/UserTransaction");
        }
        catch (NameNotFoundException e) {
            return ictx.proceed();
        }
        catch (Exception e) {
            throw new RuntimeException("Application Server does not comply with specs",e);
        }
        throw new RuntimeException("Application Server does not comply with specs");
        
    }
    
}
