/*
 * BasicCMTBean.java
 *
 * Created on November 14, 2006, 11:23 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package be.aca.misc.ejb3;

import javax.ejb.Stateless;
import javax.interceptor.Interceptors;
import javax.naming.InitialContext;
import javax.naming.NameNotFoundException;

/**
 *
 * @author stijn
 */
@Stateless(name="BasicCMTBean")
public class BasicCMTBean implements BasicCMTLocal, BasicCMTRemote {
    
    /** Creates a new instance of BasicCMTBean */
    public BasicCMTBean() {
    }
    
    
    /* Method checks that the contains complies with the EJB 3.0 specification
     * p. 448
     */
    public boolean compliesWithEJBSpec() {
        try {
            InitialContext ctx = new InitialContext();
            ctx.lookup("java:comp/UserTransaction");
        } catch (NameNotFoundException e) {
            return true;
        } catch (Exception e) {
            return false;
        }
        return false;
    }
    
    @Interceptors({TransactionInterceptor.class})
    public boolean compliesWithEJBSpecInInterceptor() {
        return true;
    }
    
}
